###########################################################################
#
#   Copyright (c) 2001 Erik Enge <erik@thingamy.net>.
#   Copyright (c) 2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Id: make_product.py,v 1.1.1.1 2001/07/04 22:50:32 erik Exp $
# $Source: /cvs/make_product/make_product.py,v $
__version__='$Revision: 1.1.1.1 $'[11:-2]

"""This class provides methods for creating classes, their associated
files, attributes, methods and various other nitbits.  Everything
created is (or should be) compliant with the Zope Python Product API.

(I'm not actually sure if there is such a thing, but reading
source-code has got me this far.)"""

from Globals import HTMLFile
from Globals import Persistent
from Globals import InitializeClass
from Products.WarpFramework import base_item, product_base_item
from AccessControl import ClassSecurityInfo

import Acquisition
import AccessControl.Role
import OFS.Folder

import product

make_product_add_form = HTMLFile('dtml/make_product_add_form', globals())
make_product_add = HTMLFile('dtml/make_product_add', globals())

def manage_add_make_product(self, id, REQUEST=None, **kw):
    """Add an instance of the make_product class"""
    self._setObject(id, make_product(id, kw))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class make_product(
    OFS.Folder.Folder,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager,
    product_base_item.product_base_item,
    base_item.base_item
    ):
    """Provide methods for setting up a Python Product that is
    compatible with the Zope Python Product API."""
    
    meta_type = 'make_product'
    icon = 'misc_/MakeProduct/Folder_icon.gif'

    _properties = (
        {'id':'title', 'type':'string', 'default':''},
        )

    manage_options = (
        {'label':'Contents', 'action':'manage_main'},
        {'label':'Edit', 'action':'base_edit'},
        {'label':'View', 'action':'index_html'},
        )

    security = ClassSecurityInfo()

    security.declarePublic('standard_html_header')
    standard_html_header = HTMLFile('dtml/standard_html_header', globals())
    security.declarePublic('standard_html_footer')
    standard_html_footer = HTMLFile('dtml/standard_html_footer', globals())

    security.declarePublic('__init__')
    def __init__(self, id, values={}):
        """Initialize the class instance"""
        self.id = id

        for property in self._properties:
            if property['id'] in values.keys():
                self._setPropValue(property['id'], values[property['id']])
            elif property.has_key('default'):
                self._setPropValue(property['id'], property['default'])

    def instanciate_product(self, *args):
        """Return an instance of the zope_product class"""
        return apply(self.product.zope_product, args)

InitializeClass(make_product)
