#!/usr/bin/env python
"""Tests for the klass.py-module."""

# $Id: test_klass.py,v 1.1.1.1 2001/07/04 22:50:35 erik Exp $
# $Source: /cvs/make_product/tests/test_klass.py,v $
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

import unittest
import klass

class basic_klass_test_case(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.basic_klass('id')

    def runTest(self):
        """basic_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.subklasses == [], \
               "runTest failed on subklasses"

class basic_klass_list_subklasses(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.basic_klass('id')

    def test_list_subklasses(self):
        """test_list_subklasses"""
        assert self.klass.list_subklasses() == [], \
               "test_list_subklasses failed on []"

class basic_klass_add_subklass(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.basic_klass('id')
        self.klass.add_subklass('id')

    def test_add_subklass(self):
        """test_add_subklass"""
        assert self.klass.list_subklasses()[0].id == 'id', \
               "test_add_subklass failed on 'id'"

class method_klass_test_case(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass('id')

    def runTest(self):
        """method_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.methods == [], \
               "runTest failed on methods"

class method_klass_list_methods(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass('id')

    def test_list_methods(self):
        """test_list_methods"""
        assert self.klass.list_methods() == [], \
               "test_list_methods failed on list_methods()"

class method_klass_add_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass('id')
        self.klass.add_method('id')

    def test_add_method(self):
        """test_add_method"""
        assert self.klass.list_methods()[0].id == 'id', \
               "test_list_methods failed on 'id'"

class method_klass_remove_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass('id')
        self.klass.add_method('id')

    def test_remove_method(self):
        """test_remove_method"""
        self.klass.remove_method('id')
        assert self.klass.list_methods() == [], \
               "test_remove_method failed on []"

class method_klass_get_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass('id')
        self.klass.add_method('id')

    def test_get_method(self):
        """test_get_method"""
        assert self.klass.get_method('id'), \
               "test_remove_method failed on []"

class method_klass_rendrer_render_methods(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass_rendrer('id')

    def test_render_methods(self):
        """test_render_methods, no methods"""
        assert self.klass.render_methods() == "", \
               "test_render_methods failed on render_methods()"

class method_klass_rendrer_render_methods_one_method(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass_rendrer('id')
        self.klass.add_method('id')

    def test_render_methods(self):
        """test_render_methods, one method"""
        text = 'def id():\n    """doc string"""\n    pass\n\n'
        assert self.klass.render_methods() == text, \
               "test_render_methods failed on render_methods()"

class method_klass_rendrer_render_methods_two_methods(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.method_klass_rendrer('id')
        self.klass.add_method('id')
        self.klass.add_method('id2')

    def test_render_methods(self):
        """test_render_methods, two methods"""
        text = 'def id():\n    """doc string"""\n    pass\n\n'+ \
               'def id2():\n    """doc string"""\n    pass\n\n'
        assert self.klass.render_methods() == text, \
               "test_render_methods failed on render_methods()"

class property_klass_test_case(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass('id')

    def runTest(self):
        """property_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.properties == [], \
               "runTest failed on properties"

class property_klass_list_properties(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass('id')

    def test_list_properties(self):
        """test_list_properties"""
        assert self.klass.list_properties() == [], \
               "test_list_properties failed on []"

class property_klass_add_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass('id')
        self.klass.add_property('id')

    def test_add_property(self):
        """test_add_property"""
        assert self.klass.list_properties()[0].id == 'id', \
               "test_add_property failed on []"

class property_klass_remove_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass('id')
        self.klass.add_property('id')

    def test_remove_property(self):
        """test_remove_property"""
        self.klass.remove_property('id')
        assert self.klass.list_properties() == [], \
               "test_remove_property failed on []"

class property_klass_get_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass('id')
        self.klass.add_property('id')

    def test_get_property(self):
        """test_get_property"""
        assert self.klass.get_property('id'), \
               "test_get_property failed on 'id'"

class property_klass_rendrer_render_properties(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')

    def test_render_properties(self):
        """test_render_properties, no properties"""
        assert self.klass.render_properties() == "", \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_one_property(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')
        self.klass.add_property('id')

    def test_render_properties(self):
        """test_render_properties, one property"""
        text = "        {'id':'id', 'type':'string', 'default':'', 'mode':'w'}"
        assert self.klass.render_properties() == text, \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_two_properties(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')
        self.klass.add_property('id')
        self.klass.add_property('id2')

    def test_render_properties(self):
        """test_render_properties, two properties"""
        text = "        {'id':'id', 'type':'string', 'default':'', 'mode':'w'},\n"+ \
               "        {'id':'id2', 'type':'string', 'default':'', 'mode':'w'}"
        assert self.klass.render_properties() == text, \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_dictionary(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, no properties"""
        assert self.klass.render_properties() == "", \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_dictionary_one_property(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')
        self.klass.add_property('id')

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, one property"""
        text = "    _properties = (\n        {'id':'id', "+ \
               "'type':'string', 'default':'', 'mode':'w'}\n        )\n"
        assert self.klass.render_properties_dictionary() == text, \
               'test_render_properties_dictionary failed on "text"'

class property_klass_rendrer_render_properties_dictionary_two_properties(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.property_klass_rendrer('id')
        self.klass.add_property('id')
        self.klass.add_property('id2')

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, two properties"""
        text = "    _properties = (\n        {'id':'id', "+ \
               "'type':'string', 'default':'', 'mode':'w'},\n"+ \
               "        {'id':'id2', 'type':'string', "+\
               "'default':'', 'mode':'w'}\n        )\n"
        assert self.klass.render_properties_dictionary() == text, \
               'test_render_properties_dictionary failed on "text"'

class klass_rendrer_render_license(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_license(self):
        """test_render_license"""
        assert self.klass.render_license() == '', \
               "test_render_license failed on ''"

class klass_rendrer_render_name_and_subclasses(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_name_and_subclasses(self):
        """test_render_name_and_subclasses"""
        text = "class id(\n    Persistent,\n    Acquisition.Implicit,\n"+ \
               "    product_base_item.product_base_item,\n"+ \
               "    base_item.base_item):\n"
        assert self.klass.render_name_and_subclasses() == text, \
               "test_render_name_and_subclasses failed on 'text'"

class klass_rendrer_render_imports(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_imports(self):
        """test_render_imports"""
        text = "from Globals import HTMLFile, InitializeClass, Persistent\n"+ \
               "from Products.WarpFramework import "+ \
               "base_item, product_base_item\n"+ \
               "import Acquisition\nimport AccessControl.Role\n"+ \
               "import DateTime\n"
        assert self.klass.render_imports() == text, \
               "test_render_imports failed on 'text'"

class klass_rendrer_render_misc_definitions(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_misc_definitions(self):
        """test_render_misc_definitions"""
        text = "    meta_type = ''\n    icon = ''\n"
        assert self.klass.render_misc_definitions() == text, \
               "test_render_misc_definitions failed on 'text'"

class klass_rendrer_render_meta_types_and_accessors(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_meta_types_and_accessors(self):
        """test_render_meta_types_and_accessors"""
        text = ""
        assert self.klass.render_meta_types_and_accessors() == text, \
               "test_render_meta_types_and_accessors failed on 'text'"

class klass_rendrer_render_misc_headers(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_misc_headers(self):
        """test_render_misc_headers"""
        text = ""
        assert self.klass.render_misc_headers() == text, \
               "test_render_misc_headers failed on 'text'"

class klass_rendrer_render_add_function(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_add_function(self):
        """test_render_add_function"""
        text = "%(id)s_add_form = HTMLFile('dtml/%(id)s_add_form', globals())\n" % \
               {'id': 'id'}
        text = text + "%(id)s_add = HTMLFile('dtml/%(id)s_add', globals())\n\n" % \
               {'id': 'id'}
        text = text + """def manage_add_%(id)s(self, REQUEST=None, **kw):
    \"\"\"Add an instance of the %(id)s class\"\"\"
    id = str(DateTime.DateTime().time)[2:]
    self._setObject(id, %(id)s(id, kw))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)\n""" % {'id': 'id'}
        assert self.klass.render_add_function() == text, \
               "test_render_add_function failed on 'text'"

class klass_rendrer_render_initialize_class(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = klass.klass_rendrer('id')

    def test_render_initialize_class(self):
        """test_render_initialize_class"""
        text = "InitializeClass(id)\n"
        assert self.klass.render_initialize_class() == text, \
               "test_render_initialize_class failed on 'text'"

basic_klass_suite = unittest.TestSuite()
basic_klass_suite.addTest(basic_klass_test_case("runTest"))
basic_klass_suite.addTest(basic_klass_list_subklasses("test_list_subklasses"))
basic_klass_suite.addTest(basic_klass_add_subklass("test_add_subklass"))

method_klass_suite = unittest.TestSuite()
method_klass_suite.addTest(method_klass_test_case("runTest"))
method_klass_suite.addTest(method_klass_list_methods("test_list_methods"))
method_klass_suite.addTest(method_klass_add_method("test_add_method"))
method_klass_suite.addTest(method_klass_remove_method("test_remove_method"))
method_klass_suite.addTest(method_klass_get_method("test_get_method"))

method_klass_rendrer_suite = unittest.TestSuite()
method_klass_rendrer_suite.addTest(method_klass_rendrer_render_methods(
    "test_render_methods"))
method_klass_rendrer_suite.addTest(
    method_klass_rendrer_render_methods_one_method("test_render_methods"))
method_klass_rendrer_suite.addTest(
    method_klass_rendrer_render_methods_two_methods("test_render_methods"))

property_klass_suite = unittest.TestSuite()
property_klass_suite.addTest(property_klass_test_case("runTest"))
property_klass_suite.addTest(property_klass_list_properties(
    "test_list_properties"))
property_klass_suite.addTest(property_klass_add_property("test_add_property"))
property_klass_suite.addTest(property_klass_remove_property("test_remove_property"))
property_klass_suite.addTest(property_klass_get_property("test_get_property"))

property_klass_rendrer_suite = unittest.TestSuite()
property_klass_rendrer_suite.addTest(property_klass_rendrer_render_properties(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_one_property(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_two_properties(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary(
    "test_render_properties_dictionary"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary_one_property(
    "test_render_properties_dictionary"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary_two_properties(
    "test_render_properties_dictionary"))

klass_rendrer_suite = unittest.TestSuite()
klass_rendrer_suite.addTest(klass_rendrer_render_license("test_render_license"))
klass_rendrer_suite.addTest(klass_rendrer_render_name_and_subclasses(
    "test_render_name_and_subclasses"))
klass_rendrer_suite.addTest(klass_rendrer_render_imports("test_render_imports"))
klass_rendrer_suite.addTest(klass_rendrer_render_misc_definitions(
    "test_render_misc_definitions"))
klass_rendrer_suite.addTest(klass_rendrer_render_meta_types_and_accessors(
    "test_render_meta_types_and_accessors"))
klass_rendrer_suite.addTest(klass_rendrer_render_misc_headers(
    "test_render_misc_headers"))
klass_rendrer_suite.addTest(klass_rendrer_render_add_function(
    "test_render_add_function"))
klass_rendrer_suite.addTest(klass_rendrer_render_initialize_class(
    "test_render_initialize_class"))

runner = unittest.TextTestRunner()

runner.run(basic_klass_suite)
runner.run(method_klass_suite)
runner.run(method_klass_rendrer_suite)
runner.run(property_klass_suite)
runner.run(property_klass_rendrer_suite)
runner.run(klass_rendrer_suite)

def test_suite():
    """Return a unittest.TestSuite instance"""
    return unittest.TestSuite((basic_klass_suite,
                               method_klass_suite,
                               method_klass_rendrer_suite,
                               property_klass_suite,
                               property_klass_rendrer_suite,
                               klass_rendrer_suite,))

if __name__ == '__main__':
    unittest.TextTestRunner().run(test_suite())
