#!/usr/bin/env python
"""Tests for the property.py-module."""

# $Id: test_property.py,v 1.1.1.1 2001/07/04 22:50:34 erik Exp $
# $Source: /cvs/make_product/tests/test_property.py,v $
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

import unittest
import property

class basic_property_test_case(unittest.TestCase):
    """This test case will test a basic_property instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.property = property.basic_property('id', 'type',
                                                'default', 'mode')

    def runTest(self):
        """basic_property_test_case"""
        assert self.property.id == 'id', \
               "runTest failed on 'id'"
        assert self.property.type == 'type', \
               "runTest failed on 'type'"
        assert self.property.default == 'default', \
               "runTest failed on 'default'"
        assert self.property.mode == 'mode', \
               "runTest failed on 'mode'"

class property_rendrer_test_case(unittest.TestCase):
    """This test case will test a property_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.property = property.property_rendrer('id', 'type',
                                                  'default', 'mode')

    def runTest(self):
        """property_rendrer_test_case"""
        assert self.property.id == 'id', \
               "runTest failed on 'id'"
        assert self.property.type == 'type', \
               "runTest failed on 'type'"
        assert self.property.default == 'default', \
               "runTest failed on 'default'"
        assert self.property.mode == 'mode', \
               "runTest failed on 'mode'"

class property_rendrer_render_self(unittest.TestCase):
    """This test case will test a property_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.property = property.property_rendrer('id', 'type',
                                                  "'default'", 'mode')

    def runTest(self):
        """property_rendrer_render_self"""
        text = "{'id':'id', 'type':'type', 'default':'default', 'mode':'mode'}"
        assert self.property.render_self() == text, \
               "runTest failed on property.render_self()"
               

basic_property_suite = unittest.TestSuite()
basic_property_suite.addTest(basic_property_test_case("runTest"))

property_rendrer_suite = unittest.TestSuite()
property_rendrer_suite.addTest(property_rendrer_test_case("runTest"))
property_rendrer_suite.addTest(property_rendrer_render_self("runTest"))

runner = unittest.TextTestRunner()

runner.run(basic_property_suite)
runner.run(property_rendrer_suite)

def test_suite():
    """Return a unittest.TestSuite instance"""
    return unittest.TestSuite((basic_property_suite,
                               property_rendrer_suite))

if __name__ == '__main__':
    unittest.TextTestRunner().run(test_suite())
